#/usr/bin/perl
# Closed captions extraction suite, version 2.0
# Binary CC to .srt converter
# (c)2006 Ilya Zverev
$fps = 30000.0/1001.0; # NTSC 29.970
#$fps = 25.0; # PAL 25

undef $/;
my $stream = <>;
$stream =~ s/\x00\x00\x01\xB2CC\x01\xF8//g;
$stream =~ s/\xFE[^\xFF]+\xFF//g;
$stream =~ s/^.+?\xFF//g;
$stream =~ s/\x1E//g;
$stream =~ tr/\x80-\xFF/\x00-\x7F/;
#print $stream;

my $cnt = 1;
while($stream =~ /(\x14\x20.+?\x14\/)/gcs) {
	my $sub = $1;
	my $starttime = pos($stream)-2;
	$stream =~ /\x14,/gc;
	my $endtime = pos($stream)-2;
	pos($stream) = $starttime;
	
	$sub =~ s/\x14[p-zPT]/\n/g;
	$sub =~ s/\x12[PT]/\n/g;
	$sub =~ s/\x11[p-t]/\n/g;

	$sub =~ s/\x11\x37/#/g;

	$sub =~ s/\x00//g;
	$sub =~ s/\x17[\x20-\x28]//g;
	$sub =~ s/\x14.//g;
	$sub =~ s/\x12\x29//g;
	$sub =~ s/\x11.//g;
	$sub =~ s/[\x1B-\x1E\x16\x19\x0F\x0C]//g;
	$sub =~ s/\x13\x70//g;

	$sub =~ s/^\n+//g;
	$sub =~ s/\n+$//g;
	$sub =~ s/\n\n/\n/g;
	print $cnt++, "\n", postotime($starttime), " --> ", postotime($endtime), "\n$sub\n\n";
}

sub postotime {
	my $pos = shift @_;
	my $time = int(500*$pos/$fps); #  
	my $msec = $time%1000;
	my $sec = int($time/1000)%60;
	my $min = int($time/60000)%60;
	my $hour = int($time/3600000);
	return sprintf "%02d:%02d:%02d,%03d", $hour, $min, $sec, $msec;
}