#/usr/bin/perl
# Closed captions extraction suite, version 2.0
# CC from .VOB extractor
# (c)2006 Ilya Zverev

undef $/;
my $cc = "\x00\x00\x01\xB2CC\x01\xF8";
my $blocksize = 100;
my $cntdisplay = int(1024*1024*1024/60/$blocksize);

open CC, ">>closed-captions.bin" or die "Cannot open output file";
binmode CC;

$isfirst = 1;

foreach $file (@ARGV) {
	if( open(FILE, "<$file") ) {
		print $file;
		my $active = '';
		my $passive = '';
		if( sysread(FILE, $passive, $blocksize) < $blocksize ) {
			print "File $file is too small\n";
			next;
		}
		binmode FILE;
		$cnt = 0;
		while(1) {
			$active = $passive;
			$r = sysread FILE, $passive, $blocksize;
			if( !defined($r) || !$r ) {
				last;
			}
			print '.' if (++$cnt)%$cntdisplay == 0;
			if( ($active.$passive) =~ /($cc.{10,90})\0\0\x01\0\0/ ) {
				print CC $1 if !$isfirst;
				$isfirst = 0;
				$passive = '';
			}
		}
		print "\n";
		close FILE;
	}
}

close CC;